// Keyboard by Robokalle V.0.9.02 7,4,2019
#include <U8x8lib.h>
U8X8_SSD1306_128X64_NONAME_SW_I2C u8x8(/* clock=*/ SCL, /* data=*/ SDA, /* reset=*/ U8X8_PIN_NONE);   // OLEDs without Reset of the Display

#include <EEPROM.h>
#include <Keypad.h>
#include <XpressNet.h>
XpressNetClass XpressNet;
byte LedPin = 13;
uint8_t altPos = 0;
unsigned long zeit = 0;
unsigned long Tastendruckzeit = 3;

unsigned long previousMillis = 0;        // will store last time LED was updated
const long interval = 1000;           // interval at which to blink (milliseconds)
//--------------------------------------------------------------
// XpressNet address: must be in range of 1-31; must be unique. Note that some IDs
// are currently used by default, like 2 for a LH90 or LH100 out of the box, or 30
// for PC interface devices like the XnTCP.
byte XNetAddress = 28;    //Adresse im XpressNet
#define XNetSRPin 10       //Max485 Busdriver Send/Receive-PIN

#define Font1  u8x8_font_victoriabold8_r
#define Font2 u8x8_font_courB18_2x3_r
#define x1 10  // ABCD und Abstand
#define y1 1 // ABCD und Abstand
byte a[4] = {0, 2, 4, 6};//Abstand
#define x2 2 //Weiche
#define x3 1 //Weiche
#define xw 0 //Weichegroß
#define yw 2 //Weichegroß
#define xa  0 // Adresszeile
#define ya  5 // Adresszeile

const byte ROWS = 4; //four rows
const byte COLS = 4; //three columns
char keys[ROWS][COLS] = {
  {'1', '2', '3', 'A'},
  {'4', '5', '6', 'B'},
  {'7', '8', '9', 'C'},
  {'*', '0', '#', 'D'}
};
byte rowPins[ROWS] = {9, 8, 7, 6}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {5, 4, 3, 2}; //connect to the column pinouts of the keypad
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );
char eingabe;

uint8_t schraeg[8] = {0x04, 0x09, 0x12, 0x24, 0x48, 0x90, 0x20, 0xC0};// Weichensymbole
uint8_t gerade[8] = {0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF};
uint8_t schraeg_1[8] = {0x00, 0x01, 0x02, 0x04, 0x78, 0x00, 0x00, 0x00};
uint8_t gerade_1[8] = {0x00, 0x00, 0x00, 0x00, 0x7E, 0x00, 0x00, 0x00};

typedef struct
{ byte adresse_low;
  byte adresse_high;
  byte richtung;
}  Weichen_type;
Weichen_type Weiche[5];

byte Tastendruck = 0;
int Zahlenwert[4] = {0, 0, 0, 0};
int Adresse = 2;// ist adresse 3 beginnt ja bei null
byte Weichen_abfrage;
int dumy = 0;

//--------------------------------------------------------------------------------------------
// the setup routine runs once when you press reset:
void setup() {
  u8x8.begin();
  cls(); //Display ini
  laden();
  eingabe = keypad.getKey();
  if (eingabe == 48) einstellungen();  // setup
  
  printoled(0, 0, "Keyboard", 1);
  printoled(x1, y1 + a[0], "A", 1);
  printoled(x1, y1 + a[1], "B", 1);
  printoled(x1, y1 + a[2], "C", 1);
  printoled(x1, y1 + a[3], "D", 1);
 
  ausgabememo();
  printoled(xa, ya, String(Adresse + 1), 2);
  printweiche(xw, yw, 2, Weiche[4].richtung);

  pinMode(LedPin, OUTPUT);
  digitalWrite(LedPin, LOW);
  XpressNet.start(XNetAddress, XNetSRPin);    //Initialisierung XNet-Bus
}

//--------------------------------------------------------------------------------------------
// the loop routine runs over and over again forever:
void loop() {

  XpressNet.receive();  //permernet update the library
  eingabe = keypad.getKey();
  if (eingabe) {
    zeit = millis();
    Taste(eingabe);
  }
  if (millis() > zeit + (Tastendruckzeit * 1000)) {
      Tastendruck = 0;
    }

  //Ask for switch state
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis >= interval) {    // save the last time you blinked the LED
    previousMillis = currentMillis;
    if (Weichen_abfrage == 1) XpressNet.getTrntInfo(Weiche[4].adresse_high, Weiche[4].adresse_low); 
  }
}

//--------------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------------


void Taste(char key) {
  switch (key) {
    case 'A':
      if (Tastendruck > 0) {
        inMemo(0);
      }
      else {
        ausMemo(0);
      }
      break;
    case 'B':
      if (Tastendruck > 0) {
        inMemo(1);
      }
      else {
        ausMemo(1);

      }
      break;
    case 'C':
      if (Tastendruck > 0) {
        inMemo(2);
      }
      else {
        ausMemo(2);

      }
      break;
    case 'D':
      if (Tastendruck > 0) {
        inMemo(3);
      }
      else {
        ausMemo(3);
      }
      break;
    case '*':
      Weiche[4].richtung = 0;
      Weichestellen(Weiche[4].adresse_high, Weiche[4].adresse_low, Weiche[4].richtung ); //switch rund
      printweiche(xw, yw, 2, 0);
      speichern(4);
      break;
    case '#':
      Weiche[4].richtung = 1;
      Weichestellen(Weiche[4].adresse_high, Weiche[4].adresse_low, Weiche[4].richtung ); //switch  gerade
      printweiche(xw, yw, 2, 1);
      speichern(4);
      break;
    default:
      break;
  }
  if ((key >= 48) && (key <= 57)) {
    Zahlenwert[Tastendruck] = key - 48 ;

    if (Tastendruck == 0) {
      dumy = Zahlenwert[0];
    }
    if (Tastendruck == 1) {
      dumy = 0;
      dumy = dumy + (Zahlenwert[0] * 10);
      dumy = dumy + Zahlenwert[1];
    }
    if (Tastendruck == 2) {
      dumy = 0;
      dumy = dumy + (Zahlenwert[0] * 100);
      dumy = dumy + (Zahlenwert[1] * 10);
      dumy = dumy + Zahlenwert[2];
    }
    if (Tastendruck == 3) {
      dumy = 0;
      dumy = dumy + (Zahlenwert[0] * 1000);
      dumy = dumy + (Zahlenwert[1] * 100);
      dumy = dumy + (Zahlenwert[2] * 10);
      dumy = dumy + Zahlenwert[3];
    }

    if ((Zahlenwert[0] == 0) && (Tastendruck == 0)) { // wird 0 als erstes gedrückt ab zum menu
      menu();
    }
    else {
      Adresse = dumy - 1; // minus 1 wegen null beginnend
      if (Adresse > 1023) Adresse = 1023;
      if (Adresse >= 0) printoled(xa, ya, String(Adresse + 1), 2);

      Weiche[4].adresse_low = (Adresse ) % 256;
      Weiche[4].adresse_high  = (Adresse ) / 256 ;
      Weiche[4].richtung = 0;

      if (Zahlenwert[0] > 0) {
        Tastendruck++;
      }
      if (Tastendruck > 4) {
        Tastendruck = 0;
      }
    }
  }
}

void printoled(byte posx, byte posy, String text, byte groesse) {
  if (groesse == 2)  u8x8.setFont(Font2);
  if (groesse == 1)  u8x8.setFont(Font1 );
  u8x8.setCursor(posx, posy);
  u8x8.print("    ");
  u8x8.setCursor(posx, posy);
  u8x8.print(text);
}

void printweiche(byte posx, byte posy, byte groesse, byte richtung) {
  if (richtung == 0) {
    if (groesse == 2) {
      u8x8.drawTile(posx, posy, 1, schraeg);
      u8x8.drawTile(posx, posy + 1, 1, gerade);
    }
    else {
      u8x8.drawTile(posx, posy, 1, schraeg_1);
    }
  }
  else {
    if (groesse == 2) {
      u8x8.drawTile(posx, posy, 1, gerade);
      u8x8.drawTile(posx, posy + 1, 1, gerade);
    }
    else {
      u8x8.drawTile(posx, posy, 1, gerade_1);
    }

  }

}
void cls(void)
{
  //u8x8.setFlipMode(1);
  u8x8.clear();
  //u8x8.setFont(Font1);
  //u8x8.inverse();
  //u8x8.noInverse();

}


void inMemo(byte i) {
  printoled(x1 + x2, y1 + a[i], String(Adresse + 1), 1);
  Weiche[i].adresse_low =  Weiche[4].adresse_low;
  Weiche[i].adresse_high = Weiche[4].adresse_high;
  Weiche[i].richtung =  Weiche[4].richtung;
  printweiche(x1 + x3, y1 + a[i], 1, Weiche[i].richtung);
  speichern(i);
  Tastendruck = 0;
}
void ausMemo(byte i)
{
  Adresse = (Weiche[i].adresse_high * 256) + Weiche[i].adresse_low; //
  Weichestellen(Weiche[i].adresse_high, Weiche[i].adresse_low, Weiche[i].richtung); //switch
  Weiche[4].adresse_high = Weiche[i].adresse_high;
  Weiche[4].adresse_low = Weiche[i].adresse_low;
  Weiche[4].richtung = Weiche[i].richtung;
  printoled(xa, ya, String(Adresse + 1), 2);
  printweiche(xw, yw, 2, Weiche[i].richtung);
  Tastendruck = 0;
}
void speichern(byte i) {
  int j = 0;
  j = i * 3;
  EEPROM.write(j, Weiche[i].adresse_high );
  EEPROM.write(j + 1, Weiche[i].adresse_low );
  EEPROM.write(j + 2 , Weiche[i].richtung  );
}

void laden() {
  int j = 0;
  byte i;
  for ( i = 0; i < 5 ; i++) {
    Weiche[i].adresse_high = EEPROM.read(j);
    Weiche[i].adresse_low = EEPROM.read(j + 1);
    Weiche[i].richtung = EEPROM.read(j + 2);
    Adresse = (Weiche[i].adresse_high * 256) + Weiche[i].adresse_low ;
    j = j + 3;
  }
  XNetAddress = EEPROM.read(15);
  if (XNetAddress > 31) XNetAddress = 28; // falls eeprom noch leer
  Weichen_abfrage = EEPROM.read(16);
  if (Weichen_abfrage > 1) Weichen_abfrage = 1; // falls eeprom noch leer
  Tastendruckzeit = EEPROM.read(17);
  if (Tastendruckzeit > 3) Tastendruckzeit = 3; // falls eeprom noch leer

}
void ausgabememo() {
   byte i;
  for ( i = 0; i < 4 ; i++) {
    Adresse = (Weiche[i].adresse_high * 256) + Weiche[i].adresse_low ;
    printweiche(x1 + x3, y1 + a[i], 1, Weiche[i].richtung);
    printoled(x1 + x2, y1 + a[i], String(Adresse + 1), 1);
  }

}
void einstellungen() {
  dumy = 0;
  Tastendruck = 0;
  char key;
  printoled(0, 1, " Xpress Adresse ", 1);
  printoled(2, 4, String( XNetAddress ), 1);

  while (key != '#') {
    key = keypad.getKey();
    if ((key >= 48) && (key <= 57)) {
      Zahlenwert[Tastendruck] = key - 48 ;
      if (Tastendruck == 0) {
        dumy = Zahlenwert[0];
      }
      if (Tastendruck == 1) {
        dumy = 0;
        dumy = dumy + (Zahlenwert[0] * 10);
        dumy = dumy + Zahlenwert[1];
      }
      if (Zahlenwert[0] > 0) {
        Tastendruck++;
      }
      if (Tastendruck > 1) {
        Tastendruck = 0;
      }
      XNetAddress = dumy;
      if (XNetAddress > 31) XNetAddress = 31;
      printoled(2, 4 , "  ", 1);
      printoled(2, 4 , String( XNetAddress ), 1);
    }

  }
  EEPROM.write(15 , XNetAddress);
  cls();
  printoled(0, 1, " Lenz/0 oder", 1);
  printoled(0, 2, " Roco/1", 1);
  printoled(2, 4, String( Weichen_abfrage), 1);
  key = keypad.getKey();
  while (key != '#') {
    key = keypad.getKey();
    if ((key >= 48) && (key <= 49)) {
      Weichen_abfrage = key - 48;
      printoled(2, 4 , "  ", 1);
      printoled(2, 4 , String( Weichen_abfrage ), 1);
    }
  }
  EEPROM.write(16 , Weichen_abfrage);
  cls();
  printoled(0, 1, " Tastenabfrage", 1);
  printoled(0, 2, " 1 bis 3 Sek.", 1);
  printoled(2, 4, String( Tastendruckzeit), 1);
  key = keypad.getKey();
  while (key != '#') {
    key = keypad.getKey();
    if ((key >= 49) && (key <= 51)) {
      Tastendruckzeit = key - 48;
      printoled(2, 4 , "  ", 1);
      printoled(2, 4 , String( Tastendruckzeit ), 1);
    }
  }
  EEPROM.write(17 , Tastendruckzeit);
  cls();
}
void Weichestellen(uint8_t Adr_High, uint8_t Adr_Low, uint8_t Pos) { //switch 18 gerade aus
  XpressNet.setTrntPos(Adr_High, Adr_Low, Pos + 8); //ein
  delay(100);// warten bis wieder aus estellt wird
  XpressNet.setTrntPos(Adr_High, Adr_Low, Pos); //aus
}

void menu() {
  printoled(xa, ya, " M  ", 2);
  Status();
  printoled(xa, ya, String(Adresse + 1), 2);
  Tastendruck == 0;
}

void Status() {
  if (XpressNet.getPower() == csNormal) {
    XpressNet.setPower(csTrackVoltageOff);  // Wenn Power dann Off
  }
  else {
    XpressNet.setPower(csNormal);  //  ansonsten Power on
  }

}

void notifyXNetPower (uint8_t State)
{
  printoled(0, 0, "                ", 1);
  switch (State) {
    case csNormal: printoled(1, 0, "Power on", 1); break;
    case csTrackVoltageOff: printoled(1, 0, "Power off", 1); break;
    case csEmergencyStop: printoled(1, 0, "Nothalt", 1); break;
    case csShortCircuit: printoled(1, 0, " Kurzschluss ", 1); break;
    case csServiceMode: printoled(1, 0, "Programmieren", 1); break;
  }
}
void notifyTrnt(uint8_t Adr_High, uint8_t Adr_Low, uint8_t Pos)
{
  if ((Adr_Low == Weiche[4].adresse_low) && (Adr_High == Weiche[4].adresse_high)) {
    if (Pos != altPos) {
      if (Pos == B10) {
        printweiche(xw, yw, 2, 1);
        altPos = Pos;
      }
      if (Pos == B01)  {
        printweiche(xw, yw, 2, 0);
        altPos = Pos;
      }
    }
  }
}

//-----------------------------------------------------------
void notifyXNetStatus (uint8_t State)
{
  digitalWrite(LedPin, State);
}
